<!--
 * @Author: zhp
 * @Date: 2023-02-14 15:02:26
 * @LastEditTime: 2023-05-15 14:24:05
 * @LastEditors: zhp
 * @Description: 
-->
<template>
  <el-form :model="dataForm" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" label-width="150px">
    <el-form-item prop="code" :label="$t('laboratory.code')">
      <el-input v-model="dataForm.code" :placeholder="$t('laboratory.code')">
      </el-input>
    </el-form-item>
    <el-form-item prop="name" :label="$t('laboratory.name')">
      <el-input v-model="dataForm.name" :placeholder="$t('laboratory.name')">
      </el-input>
    </el-form-item>
    <el-form-item prop="getDate" :label="$t('laboratory.getDate')">
      <el-date-picker v-model="dataForm.getDate" type="datetime" :placeholder="$t('laboratory.getDate')"
        format='yyyy-MM-dd HH:mm:ss' valueFormat='yyyy-MM-ddTHH:mm:ss'>
      </el-date-picker>
    </el-form-item>
    <el-form-item prop="validDate" :label="$t('laboratory.validDate')">
      <el-date-picker v-model="dataForm.expectedReturnDate" type="datetime" :placeholder="$t('laboratory.validDate')"
        format='yyyy-MM-dd HH:mm:ss' valueFormat='yyyy-MM-ddTHH:mm:ss'>
      </el-date-picker>
    </el-form-item>
    <el-form-item prop="qualificationDescription" :label="$t('laboratory.qualificationDescription')">
      <el-input v-model="dataForm.qualificationDescription" :placeholder="$t('laboratory.qualificationDescription')">
      </el-input>
    </el-form-item>
    <el-form-item prop="remark" :label="$t('laboratory.remark')">
      <el-input v-model="dataForm.remark" :placeholder="$t('laboratory.remark')">
      </el-input>
    </el-form-item>
  </el-form>
</template>

<script>
import debounce from "lodash/debounce";
import basicAdd from "@/mixins/basic-add";
export default {
  mixins: [basicAdd],
  data() {
    return {
      urlOptions: {
        submitURL: "/laboratory/qmsLaboratoryTesterInspectionQualification",
        infoURL: "/laboratory/qmsLaboratoryTesterInspectionQualification/{ id }",
        // getGageListURL: '/gage/qmsGage/page',
        // getTeamListURL: '/basic/qmsTeam/gape',
        // getProductURL: '/basic/qmsProduct/gape',
        // getSupplierListURL: '/supplier/qmsSupplier/gape'
      },
      gageList:[],
      // supplierList:[],
      // productList:[],
      // typeList: [],
      // teamList:[],
      listQuery: {
        limit: 999,
        gape: 1
      },
      visible: false,
      dataForm: {
        laboratoryTesterId:null,
        code:null,
        getDate: null,
        id: null,
        laboratoryTesterId: null,
        name: null,
        qualificationDescription: null,
        remark: null,
        validDate: null
      },
    };
  },
  computed: {
    dataRule() {
      return {
        // dictLabel: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // dictValue: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
        // sort: [
        //   {
        //     required: true,
        //     message: this.$t("validate.required"),
        //     trigger: "blur",
        //   },
        // ],
      };
    },
  },
  mounted () {
    this.getData();
  },
  methods: {
    init(data) {
      this.dataForm.id = data.id ? data.id: ''
      this.dataForm.laboratoryTesterId = data.laboratoryTesterId ? data.laboratoryTesterId : ''
      // console.log(11111)
      // this.dataForm.dictTypeId = dictTypeId || "";
      this.visible = true
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo()
        } else {
          // this.getCode()
        }
      });
    },
    getData() {
      // this.$http
      //   .get(this.urlOptions.getTypeListURL, this.listQuery)
      //   .then(({ data: res }) => {
      //     if (res.code === 0) {
      //       console.log(res.data);
      //       this.typeList = res.data.list
      //     }
      //   })
      //   .catch(() => {
      //   });
      this.$http
        .get(this.urlOptions.getGageListURL, this.listQuery)
        .then(({ data: res }) => {
          if (res.code === 0) {
            console.log(res.data);
            this.gageList = res.data.list
          }
        })
        .catch(() => {
        })
    },
    // getCode() {
    //   this.$http.post(this.urlOptions.getCodeURL)
    //     .then(({ data: res }) => {
    //       if (res.code === 0) {
    //         console.log(res);
    //         this.dataForm.customSamplingCode = res.data
    //       }
    //     })
    //     .catch(() => {
    //     });
    // },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/laboratory/qmsLaboratoryTesterInspectionQualification/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => { })
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](this.urlOptions.submitURL, this.dataForm)
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  console.log(1111);
                  this.visible = false;
                  this.$emit("successSubmit");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
